/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2005 by Walther Neuper
 * created Jun 17, 2005 7:08:04 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.util.formulae;

import junit.framework.TestCase;

/**
 * @author Walther Neuper
 */
public class TestModel extends TestCase {

    public void testToSMLstring() {
        System.out.println("---BEGIN isac.util.formulae.TestModel");
        System.out.println("---BEGIN TestModel#testToSMLstring");
        Model m = new Model();
        ModelItemList its;
        ModelItem it1, it2;

        its = new ModelItemList();
        it1 = new ModelItem();
        it2 = new ModelItem();
        it1.setText("equality (x+1=2)");
        it1.setItemStatus("correct");
        it2.setText("solveFor x");
        it2.setItemStatus("correct");
        its.addItem(it1);
        its.addItem(it2);
        m.setGiven(its);//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        its = new ModelItemList();
        it1 = new ModelItem();
        it1.setText("matches (?a = ?b) (x+1=2)");
        it1.setItemStatus("correct");
        its = new ModelItemList();
        its.addItem(it1);
        m.setWhere(its);//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        its = new ModelItemList();
        it1 = new ModelItem();
        it1.setText("solutions L");
        it1.setItemStatus("correct");
        its = new ModelItemList();
        its.addItem(it1);
        m.setFind(its);//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        //m.setRelate !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        //the format preparing for stdin to SML-kernel
        String test = ""//.................................................
                + "Given [\"equality (x+1=2)\", \"solveFor x\"], "//........
                //+ "Where [\"matches (?a = ?b) (x+1=2)\"], "//........
                + "Find [\"solutions L\"], "//................................
                + "Relate []"//..............................................
                + "";
        System.out.println("test=           " + test);
        System.out.println("m.toSMLString()=" + m.toSMLString());
        assertEquals(m.toSMLString(), test);

        //the format containing all data
        //        test = ""//..............................................
        //            + "Given [correct \"equality (x+1=2)\", "
        //            + /* */"correct \"solveFor x\"], "//........
        //            + "Where [correct \"matches (?a = ?b) (x+1=2)\"], "//...
        //            + "Find [correct \"solutions L\"],//............
        //            + "Relate []"//....................................
        //            + "";
        //FIXXXME.WN050617 get off the quotes from item_status_ ?!?:..
        test = ""//.................................................
                + "Given [\"correct equality (x+1=2)\", "
                + /*   */"\"correct solveFor x\"], "//........
                + "Where [\"correct matches (?a = ?b) (x+1=2)\"], "//........
                + "Find [\"correct solutions L\"], "//.......................
                + "Relate []"//..............................................
                + "";
        System.out.println("test=           " + test);
        System.out.println("m.toString()=   " + m.toString());
        assertEquals(m.toString(), test);

        System.out.println("---END TestModel#testToSMLstring");
        System.out.println("---END isac.util.formulae.TestModel");
    }

}