/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2005 by Walther Neuper 
 * created Apr 15, 2005 8:26:54 AM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.util.users;

import isac.session.SDialog;
import isac.util.InformationProcessor;
import isac.util.users.IUserSettings;
import isac.util.users.User;
import isac.util.users.UserSettings;

import java.rmi.RemoteException;

import junit.framework.TestCase;

/**
 * @author neuper
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class TestUser extends TestCase {

	/**
	 * set up a minimal testbed for getting UserSettings
	 * 
	 * @exception RemoteException
	 *                if SessionDialog=ObjectManager NOT launched (ObjectManager
	 *                launchedd after KEStore, BridgeMain)
	 * @see isac.kestore.TestSessionDialog#testLogin
	 */
	public void testGetUserSettings() {
		System.out
				.println("---BEGIN isac.util.user.TestUser#testGetUserSettings");

		// see isac.gui.WindowApplication#login
		String session_id = InformationProcessor.login("x", "x");
		assertEquals("sessionID from InformationProcessor.login", session_id,
				"x0");
		SDialog session_dialog = InformationProcessor.getSDialog();

		// see isac.wsdialog.DialogGuide#constructor
		User user = null;
		try {
			user = session_dialog.getUser(session_id);
		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		String usern = user.getUsername();
		assertEquals("username", usern, "x");

		//this stores the whole UserSettings in the local 'user_settings'
		UserSettings user_settings = user.getUserSettings();
		
		// in isac/xmldata/users/x_settings.txt we have:
		// key = IUserSettings.start_worksheet
		// val = IUserSettings.SKIP_SPECIFY_START_SOLVE
		int val = user_settings.getValue(IUserSettings.KEY1_START_SPECIFY);
		assertEquals("getValue(IUserSettings.KEY1_START_SPECIFY)", val,
				IUserSettings.VAL1_SKIP_SPECIFY_TO_START_SOLVE);

		System.out.println("---END isac.util.user.TestUser#testGetUserSettings");
	}


	
}
