/****************************************************************** 
 * Copyright (c) 2003, Mario Hochreiter, Student of 
 * Software Engineering at FH-Hagenberg, Austria. 
 * Project member of the isac team at the Institute for 
 * Software-Technologie, Graz University of Technology, Austria. 
 * 
 * Use is subject to license terms.
 ******************************************************************/

package isac.gui.browser.example;

import isac.util.*;

//import isac.util.InformationProcessor;
import isac.gui.browser.ContentPanel;
import isac.gui.browser.TabPanel;
import isac.gui.util.ExampleNode;
import isac.gui.util.Hierarchy;
//import isac.util.*;
import isac.util.parser.*;
import isac.wsdialog.DialogGuide;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.rmi.RemoteException;

import javax.swing.JFrame;
import javax.swing.tree.TreePath;

import org.apache.log4j.Logger;

/**
 * @author Mario Hochreiter
 * @version 1.0
 */

public class ExampleBrowserPanel extends TabPanel {

    static Logger logger_ = Logger.getLogger(ExampleBrowserPanel.class
            .getName());

    public ExampleBrowserPanel(JFrame root, Hierarchy hierarchy) {
        super(root, hierarchy);
        this.initMouseListener();
    }

    protected void initMouseListener() {
        ml_ = new MouseAdapter() {

            public void mousePressed(MouseEvent e) {
                int selRow = view_tree_.getRowForLocation(e.getX(), e.getY());
                TreePath selPath = view_tree_.getPathForLocation(e.getX(), e
                        .getY());
                if (selRow != -1) {
                    if (e.getClickCount() == 2) {
                        ExampleNode selNode = (ExampleNode) selPath
                                .getLastPathComponent();
                        ContentPanel cp = root_.getContentPanel();
                        if (selNode.getContentref() != null) {
                            cp.setContent("exp", selNode.getContentref());
                            root_.showContentFrame();
                        } else if (selNode.getExample() != null) {
                            cp.setContent("exp", selNode.getExample());
                            String xmlString = InformationProcessor.loadXML(
                                    root_.getSessionId(), "exp", selNode
                                            .getExample());
                            logger_.info(xmlString);
                            FormalizationDigest fd = new FormalizationDigest();
                            Formalization f = fd.parseFormalization(xmlString);
                            logger_.info(f.toSMLString());
                            try {
                                root_.openNewWorksheet(f,
                                        DialogGuide.STARTFROM_EXAMPLE);
                            } catch (RemoteException e1) {
                                // TODO Auto-generated catch block
                                e1.printStackTrace();
                            }
                        }
                    }
                }
            }
        };
        view_tree_.addMouseListener(ml_);
    }
}