/****************************************************************** 
 * Copyright (c) 2003, Mario Hochreiter, Student of 
 * Software Engineering at FH-Hagenberg, Austria. 
 * Project member of the isac team at the Institute for 
 * Software-Technologie, Graz University of Technology, Austria. 
 * 
 * Use is subject to license terms.
 ******************************************************************/

package isac.gui.calcheadviews;

import isac.gui.util.SpringUtilities;
import isac.util.formulae.CalcHead;

import java.util.Locale;
import java.util.StringTokenizer;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JTextPane;
import javax.swing.SpringLayout;

import org.apache.log4j.Logger;

/**
 * @author Mario Hochreiter
 * @version 1.0
 * 
 * WN0504 there will be only _ONE_ CalcHead view forever...
 * @see isac.util.formulae.CalcHead#VIEWSTYLE_FULL and
 *      isac.util.formulae.CalcHead#VIEWSTYLE_SINGLELINE is used _NOT_ to show
 *      the CalcHeadPanel thus ...
 * @deprecated
 */
public class SimpleCalcHeadView extends CalcHeadView {
    static Logger logger_ = Logger
            .getLogger(SimpleCalcHeadView.class.getName());

    public SimpleCalcHeadView(Locale locale, CalcHead ch) {
        super(locale);
        this.init();
        this.fillTextFieldsFromCalcHead(ch);
    }

    private void init() {
        this.buildTextFields();
        this.buildLabels();
        this.layoutComponents();
    }

    protected void layoutComponents() {
        this.setLayout(new SpringLayout());
        this.add(label_given_);
        this.add(txt_given_);
        SpringUtilities.makeCompactGrid(this, 1, 2, //rows, cols
                5, 5, //initialX, initialY
                5, 5);//xPad, yPad
    }

    protected void buildLabels() {
        label_given_ = new JLabel(res_bundle_.getString("solve"));
    }

    protected void buildTextFields() {
        txt_given_ = new JTextPane();
        txt_given_.setBorder(BorderFactory.createEtchedBorder());
    }

    public void fillTextFieldsFromCalcHead(CalcHead ch) {
        clearTextFields();
        txt_given_.setText(getSimpleSolveString(ch));

    }

    private String getSimpleSolveString(CalcHead ch) {
        StringBuffer sb = new StringBuffer();
        StringTokenizer st = new StringTokenizer(ch.getGiven().toSMLString(),
                ",");
        StringBuffer eq = new StringBuffer(st.nextToken());
        String equation = eq.substring(eq.indexOf("(") + 1, eq.indexOf(")"));
        logger_.info(equation);
        Character c = new Character('"');
        StringTokenizer st2 = new StringTokenizer(st.nextToken(), " "
                + c.toString());
        logger_.info(st2.nextToken());
        sb.append("(").append(equation).append(", ").append(st2.nextToken())
                .append(")");
        logger_.info(sb.toString());
        return sb.toString();
    }

    /**
     * @param ch
     *            CalcHead from wich the data is read to fill out the text
     *            fields
     */
    public void fillCalcHeadFromTextFields(CalcHead ch) {
        /* theory ; method ; problem */

        //    //given
        //    String given = txtGiven.getText();
        //    CalcHeadItemList givenList = new CalcHeadItemList();
        //    CalcHeadItem givenItem = new CalcHeadItem();
        //    givenItem.setText(given);
        //    givenList.addItem(givenItem);
        //    ch.setGiven(givenList);
        //    
        //    //where
        //    String where = txtWhere.getText();
        //    CalcHeadItemList whereList = new CalcHeadItemList();
        //    CalcHeadItem whereItem = new CalcHeadItem();
        //    whereItem.setText(where);
        //    whereList.addItem(whereItem);
        //    ch.setWhere(whereList);
        //    
        //    //find
        //    String find = txtFind.getText();
        //    CalcHeadItemList findList = new CalcHeadItemList();
        //    CalcHeadItem findItem = new CalcHeadItem();
        //    findItem.setText(find);
        //    findList.addItem(findItem);
        //    ch.setFind(findList);
        //    
        //    //relate
        //    String relate = txtRelate.getText();
        //    CalcHeadItemList relateList = new CalcHeadItemList();
        //    CalcHeadItem relateItem = new CalcHeadItem();
        //    relateItem.setText(relate);
        //    relateList.addItem(relateItem);
        //    ch.setRelate(relateList);
    }

}